from ..core.element import Prop
from .styled_element import StyledElement
from .props import (
    OptionProp,
    BoolProp,
    OptionalStrProp,
    DirectionProp,
    AlignProp,
    JustifyProp,
    GapProp,
    WrapProp,
    AriaProp,
    GridTemplateAreasProp,
    GridTemplateRowsProp,
    GridRowProp,
)


class container(StyledElement):
    is_container = True

    direction = DirectionProp("vertical")
    align = AlignProp("stretch")
    justify = JustifyProp("start")
    vertical_scroll = BoolProp(False)
    horizontal_scroll = BoolProp(False)
    gap = GapProp(None)
    layout = OptionProp("flex", ("flex", "grid"))
    # TODO: What's the type of this prop?
    grid_area = Prop(None)
    wrap = WrapProp(False)
    role = OptionalStrProp(None)
    aria = AriaProp(None)
    grid_template_columns = GridTemplateRowsProp(None)
    grid_template_rows = GridTemplateRowsProp(None)
    grid_template_areas = GridTemplateAreasProp(None)
    grid_row = GridRowProp(None)
    grid_column = GridRowProp(None)


box = container
vbox = container


class hbox(container):
    name = "container"
    direction = DirectionProp("horizontal")
